/*
  VGG Image Annotator (via)
  www.robots.ox.ac.uk/~vgg/software/via/

  Copyright (c) 2016-2018, Abhishek Dutta.
  All rights reserved.

  Redistribution and use in source and binary forms, with or without
  modification, are permitted provided that the following conditions are met:

  Redistributions of source code must retain the above copyright notice, this
  list of conditions and the following disclaimer.
  Redistributions in binary form must reproduce the above copyright notice,
  this list of conditions and the following disclaimer in the documentation
  and/or other materials provided with the distribution.
  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
  AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
  IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
  ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
  LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
  CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
  SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
  INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
  CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
  ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
  POSSIBILITY OF SUCH DAMAGE.
*/

function _via_load_submodules() {
  //toggle_attributes_editor();
  //update_attributes_update_panel();
  //annotation_editor_show();

  _via_face_track_annotation_demo_define_attributes();
  _via_face_track_annotation_demo_import();

  setTimeout( function() {
    //image_grid_toggle();
  }, 200);
/*
  setTimeout( function() {
    image_grid_group_by('region', 'track');
  }, 3000);

  setTimeout( function() {
    image_grid_group_by('file', 'shot');
  }, 2000);

*/
}

function _via_face_track_annotation_demo_import() {
  import_annotations_from_json(sherlock_e01_face_tracks_json);
}

function _via_face_track_annotation_demo_define_attributes() {
  var attributes_json = '{"region":{"track":{"type":"text"},"is_good_track":{"type":"radio","options":{"y":"Yes","n":"No"},"default_options":{"y":true}},"name":{"type":"dropdown","options":{"bc":"Benedict Cumberbatch","mf":"Martin Freeman","n/a":"Unknown"},"default_options":{"n/a":true}}},"file":{"shot":{"type":"text"}}}';

  project_import_attributes_from_json(attributes_json);
}

// source: face_track_annotation/data/sherlock_ep01_tracks_FRCNN.json
// exported using: via/demo/data/face_track_annotation/export_facetracks.m
var sherlock_e01_face_tracks_json = '{"./images/00011384.jpg63930":{"filename":"./images/00011384.jpg","size":"63930","regions":[{"shape_attributes":{"name":"rect","x":325,"y":113,"width":103,"height":132},"region_attributes":{"track":320}}],"file_attributes":{"shot":123}},"./images/00011385.jpg61891":{"filename":"./images/00011385.jpg","size":"61891","regions":[{"shape_attributes":{"name":"rect","x":330,"y":111,"width":90,"height":151},"region_attributes":{"track":320}}],"file_attributes":{"shot":123}},"./images/00011386.jpg63116":{"filename":"./images/00011386.jpg","size":"63116","regions":[{"shape_attributes":{"name":"rect","x":337,"y":128,"width":98,"height":130},"region_attributes":{"track":320}}],"file_attributes":{"shot":123}},"./images/00011387.jpg61008":{"filename":"./images/00011387.jpg","size":"61008","regions":[{"shape_attributes":{"name":"rect","x":340,"y":124,"width":97,"height":154},"region_attributes":{"track":320}}],"file_attributes":{"shot":123}},"./images/00011388.jpg62213":{"filename":"./images/00011388.jpg","size":"62213","regions":[{"shape_attributes":{"name":"rect","x":342,"y":148,"width":102,"height":134},"region_attributes":{"track":320}}],"file_attributes":{"shot":123}},"./images/00011389.jpg59656":{"filename":"./images/00011389.jpg","size":"59656","regions":[{"shape_attributes":{"name":"rect","x":350,"y":163,"width":109,"height":126},"region_attributes":{"track":320}}],"file_attributes":{"shot":123}},"./images/00011390.jpg61044":{"filename":"./images/00011390.jpg","size":"61044","regions":[{"shape_attributes":{"name":"rect","x":332,"y":164,"width":128,"height":137},"region_attributes":{"track":320}}],"file_attributes":{"shot":123}},"./images/00011391.jpg59435":{"filename":"./images/00011391.jpg","size":"59435","regions":[{"shape_attributes":{"name":"rect","x":330,"y":173,"width":145,"height":131},"region_attributes":{"track":320}}],"file_attributes":{"shot":123}},"./images/00011392.jpg60354":{"filename":"./images/00011392.jpg","size":"60354","regions":[{"shape_attributes":{"name":"rect","x":334,"y":178,"width":158,"height":133},"region_attributes":{"track":320}}],"file_attributes":{"shot":123}},"./images/00011393.jpg59314":{"filename":"./images/00011393.jpg","size":"59314","regions":[{"shape_attributes":{"name":"rect","x":340,"y":196,"width":152,"height":120},"region_attributes":{"track":320}}],"file_attributes":{"shot":123}},"./images/00011394.jpg60843":{"filename":"./images/00011394.jpg","size":"60843","regions":[{"shape_attributes":{"name":"rect","x":351,"y":207,"width":147,"height":106},"region_attributes":{"track":320}}],"file_attributes":{"shot":123}},"./images/00011395.jpg59418":{"filename":"./images/00011395.jpg","size":"59418","regions":[{"shape_attributes":{"name":"rect","x":354,"y":199,"width":142,"height":121},"region_attributes":{"track":320}}],"file_attributes":{"shot":123}},"./images/00011396.jpg60830":{"filename":"./images/00011396.jpg","size":"60830","regions":[{"shape_attributes":{"name":"rect","x":357,"y":199,"width":147,"height":102},"region_attributes":{"track":320}}],"file_attributes":{"shot":123}},"./images/00011397.jpg59160":{"filename":"./images/00011397.jpg","size":"59160","regions":[{"shape_attributes":{"name":"rect","x":360,"y":173,"width":144,"height":120},"region_attributes":{"track":320}}],"file_attributes":{"shot":123}},"./images/00011398.jpg60497":{"filename":"./images/00011398.jpg","size":"60497","regions":[{"shape_attributes":{"name":"rect","x":369,"y":163,"width":140,"height":135},"region_attributes":{"track":320}}],"file_attributes":{"shot":123}},"./images/00011399.jpg59689":{"filename":"./images/00011399.jpg","size":"59689","regions":[{"shape_attributes":{"name":"rect","x":379,"y":150,"width":139,"height":128},"region_attributes":{"track":320}}],"file_attributes":{"shot":123}},"./images/00011400.jpg61073":{"filename":"./images/00011400.jpg","size":"61073","regions":[{"shape_attributes":{"name":"rect","x":384,"y":134,"width":112,"height":138},"region_attributes":{"track":320}},{"shape_attributes":{"name":"rect","x":621,"y":165,"width":60,"height":97},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011401.jpg59665":{"filename":"./images/00011401.jpg","size":"59665","regions":[{"shape_attributes":{"name":"rect","x":392,"y":131,"width":101,"height":128},"region_attributes":{"track":320}},{"shape_attributes":{"name":"rect","x":622,"y":161,"width":61,"height":103},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011402.jpg61765":{"filename":"./images/00011402.jpg","size":"61765","regions":[{"shape_attributes":{"name":"rect","x":384,"y":103,"width":102,"height":157},"region_attributes":{"track":320}},{"shape_attributes":{"name":"rect","x":623,"y":157,"width":61,"height":110},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011403.jpg60645":{"filename":"./images/00011403.jpg","size":"60645","regions":[{"shape_attributes":{"name":"rect","x":383,"y":94,"width":100,"height":154},"region_attributes":{"track":320}},{"shape_attributes":{"name":"rect","x":624,"y":153,"width":62,"height":116},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011404.jpg61818":{"filename":"./images/00011404.jpg","size":"61818","regions":[{"shape_attributes":{"name":"rect","x":383,"y":92,"width":99,"height":146},"region_attributes":{"track":320}},{"shape_attributes":{"name":"rect","x":626,"y":149,"width":61,"height":123},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011405.jpg61012":{"filename":"./images/00011405.jpg","size":"61012","regions":[{"shape_attributes":{"name":"rect","x":370,"y":85,"width":101,"height":157},"region_attributes":{"track":320}},{"shape_attributes":{"name":"rect","x":627,"y":145,"width":62,"height":129},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011406.jpg62743":{"filename":"./images/00011406.jpg","size":"62743","regions":[{"shape_attributes":{"name":"rect","x":369,"y":90,"width":104,"height":151},"region_attributes":{"track":320}},{"shape_attributes":{"name":"rect","x":628,"y":141,"width":62,"height":136},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011407.jpg60700":{"filename":"./images/00011407.jpg","size":"60700","regions":[{"shape_attributes":{"name":"rect","x":362,"y":96,"width":107,"height":153},"region_attributes":{"track":320}},{"shape_attributes":{"name":"rect","x":629,"y":137,"width":63,"height":142},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011408.jpg61998":{"filename":"./images/00011408.jpg","size":"61998","regions":[{"shape_attributes":{"name":"rect","x":368,"y":102,"width":102,"height":148},"region_attributes":{"track":320}},{"shape_attributes":{"name":"rect","x":633,"y":138,"width":63,"height":144},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011409.jpg60294":{"filename":"./images/00011409.jpg","size":"60294","regions":[{"shape_attributes":{"name":"rect","x":358,"y":107,"width":111,"height":139},"region_attributes":{"track":320}},{"shape_attributes":{"name":"rect","x":638,"y":138,"width":62,"height":146},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011410.jpg61859":{"filename":"./images/00011410.jpg","size":"61859","regions":[{"shape_attributes":{"name":"rect","x":351,"y":111,"width":101,"height":146},"region_attributes":{"track":320}},{"shape_attributes":{"name":"rect","x":642,"y":139,"width":62,"height":148},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011411.jpg59833":{"filename":"./images/00011411.jpg","size":"59833","regions":[{"shape_attributes":{"name":"rect","x":354,"y":109,"width":100,"height":145},"region_attributes":{"track":320}},{"shape_attributes":{"name":"rect","x":646,"y":139,"width":62,"height":150},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011412.jpg61228":{"filename":"./images/00011412.jpg","size":"61228","regions":[{"shape_attributes":{"name":"rect","x":353,"y":109,"width":99,"height":148},"region_attributes":{"track":320}},{"shape_attributes":{"name":"rect","x":651,"y":142,"width":63,"height":149},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011413.jpg59009":{"filename":"./images/00011413.jpg","size":"59009","regions":[{"shape_attributes":{"name":"rect","x":353,"y":120,"width":98,"height":146},"region_attributes":{"track":320}},{"shape_attributes":{"name":"rect","x":655,"y":144,"width":65,"height":150},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011414.jpg60354":{"filename":"./images/00011414.jpg","size":"60354","regions":[{"shape_attributes":{"name":"rect","x":347,"y":117,"width":102,"height":153},"region_attributes":{"track":320}},{"shape_attributes":{"name":"rect","x":660,"y":147,"width":65,"height":149},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011415.jpg58534":{"filename":"./images/00011415.jpg","size":"58534","regions":[{"shape_attributes":{"name":"rect","x":341,"y":112,"width":114,"height":153},"region_attributes":{"track":320}},{"shape_attributes":{"name":"rect","x":664,"y":149,"width":67,"height":150},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011416.jpg59253":{"filename":"./images/00011416.jpg","size":"59253","regions":[{"shape_attributes":{"name":"rect","x":337,"y":121,"width":99,"height":149},"region_attributes":{"track":320}},{"shape_attributes":{"name":"rect","x":669,"y":152,"width":68,"height":149},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011417.jpg57325":{"filename":"./images/00011417.jpg","size":"57325","regions":[{"shape_attributes":{"name":"rect","x":336,"y":111,"width":101,"height":157},"region_attributes":{"track":320}},{"shape_attributes":{"name":"rect","x":681,"y":144,"width":65,"height":166},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011418.jpg57982":{"filename":"./images/00011418.jpg","size":"57982","regions":[{"shape_attributes":{"name":"rect","x":348,"y":122,"width":106,"height":160},"region_attributes":{"track":320}},{"shape_attributes":{"name":"rect","x":691,"y":157,"width":67,"height":145},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011419.jpg56064":{"filename":"./images/00011419.jpg","size":"56064","regions":[{"shape_attributes":{"name":"rect","x":353,"y":136,"width":103,"height":151},"region_attributes":{"track":320}},{"shape_attributes":{"name":"rect","x":702,"y":150,"width":70,"height":162},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011420.jpg56761":{"filename":"./images/00011420.jpg","size":"56761","regions":[{"shape_attributes":{"name":"rect","x":354,"y":145,"width":102,"height":147},"region_attributes":{"track":320}},{"shape_attributes":{"name":"rect","x":704,"y":147,"width":71,"height":162},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011421.jpg56137":{"filename":"./images/00011421.jpg","size":"56137","regions":[{"shape_attributes":{"name":"rect","x":366,"y":155,"width":116,"height":144},"region_attributes":{"track":320}},{"shape_attributes":{"name":"rect","x":713,"y":148,"width":68,"height":158},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011422.jpg54754":{"filename":"./images/00011422.jpg","size":"54754","regions":[{"shape_attributes":{"name":"rect","x":357,"y":153,"width":118,"height":158},"region_attributes":{"track":320}},{"shape_attributes":{"name":"rect","x":714,"y":147,"width":74,"height":171},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011423.jpg55458":{"filename":"./images/00011423.jpg","size":"55458","regions":[{"shape_attributes":{"name":"rect","x":361,"y":139,"width":116,"height":153},"region_attributes":{"track":320}},{"shape_attributes":{"name":"rect","x":713,"y":148,"width":74,"height":173},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011424.jpg54233":{"filename":"./images/00011424.jpg","size":"54233","regions":[{"shape_attributes":{"name":"rect","x":355,"y":140,"width":127,"height":162},"region_attributes":{"track":320}},{"shape_attributes":{"name":"rect","x":719,"y":146,"width":75,"height":180},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011425.jpg54858":{"filename":"./images/00011425.jpg","size":"54858","regions":[{"shape_attributes":{"name":"rect","x":356,"y":140,"width":122,"height":156},"region_attributes":{"track":320}},{"shape_attributes":{"name":"rect","x":718,"y":149,"width":80,"height":179},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011426.jpg53610":{"filename":"./images/00011426.jpg","size":"53610","regions":[{"shape_attributes":{"name":"rect","x":368,"y":142,"width":104,"height":158},"region_attributes":{"track":320}},{"shape_attributes":{"name":"rect","x":720,"y":158,"width":74,"height":181},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011427.jpg54944":{"filename":"./images/00011427.jpg","size":"54944","regions":[{"shape_attributes":{"name":"rect","x":358,"y":142,"width":117,"height":149},"region_attributes":{"track":320}},{"shape_attributes":{"name":"rect","x":727,"y":157,"width":77,"height":175},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011428.jpg52878":{"filename":"./images/00011428.jpg","size":"52878","regions":[{"shape_attributes":{"name":"rect","x":365,"y":141,"width":102,"height":148},"region_attributes":{"track":320}},{"shape_attributes":{"name":"rect","x":725,"y":160,"width":77,"height":171},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011429.jpg53937":{"filename":"./images/00011429.jpg","size":"53937","regions":[{"shape_attributes":{"name":"rect","x":350,"y":138,"width":107,"height":152},"region_attributes":{"track":320}},{"shape_attributes":{"name":"rect","x":732,"y":172,"width":68,"height":164},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011430.jpg51931":{"filename":"./images/00011430.jpg","size":"51931","regions":[{"shape_attributes":{"name":"rect","x":345,"y":131,"width":119,"height":162},"region_attributes":{"track":320}},{"shape_attributes":{"name":"rect","x":728,"y":184,"width":71,"height":164},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011431.jpg52744":{"filename":"./images/00011431.jpg","size":"52744","regions":[{"shape_attributes":{"name":"rect","x":348,"y":131,"width":100,"height":151},"region_attributes":{"track":320}},{"shape_attributes":{"name":"rect","x":726,"y":175,"width":72,"height":157},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011432.jpg51453":{"filename":"./images/00011432.jpg","size":"51453","regions":[{"shape_attributes":{"name":"rect","x":336,"y":125,"width":101,"height":154},"region_attributes":{"track":320}},{"shape_attributes":{"name":"rect","x":705,"y":183,"width":100,"height":158},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011433.jpg52270":{"filename":"./images/00011433.jpg","size":"52270","regions":[{"shape_attributes":{"name":"rect","x":316,"y":114,"width":109,"height":159},"region_attributes":{"track":320}},{"shape_attributes":{"name":"rect","x":707,"y":172,"width":77,"height":167},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011434.jpg51768":{"filename":"./images/00011434.jpg","size":"51768","regions":[{"shape_attributes":{"name":"rect","x":293,"y":115,"width":128,"height":161},"region_attributes":{"track":320}},{"shape_attributes":{"name":"rect","x":700,"y":175,"width":89,"height":170},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011435.jpg53864":{"filename":"./images/00011435.jpg","size":"53864","regions":[{"shape_attributes":{"name":"rect","x":301,"y":121,"width":97,"height":151},"region_attributes":{"track":320}},{"shape_attributes":{"name":"rect","x":693,"y":177,"width":101,"height":173},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011436.jpg52859":{"filename":"./images/00011436.jpg","size":"52859","regions":[{"shape_attributes":{"name":"rect","x":284,"y":107,"width":105,"height":163},"region_attributes":{"track":320}},{"shape_attributes":{"name":"rect","x":695,"y":176,"width":92,"height":169},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011437.jpg53359":{"filename":"./images/00011437.jpg","size":"53359","regions":[{"shape_attributes":{"name":"rect","x":264,"y":120,"width":120,"height":141},"region_attributes":{"track":320}},{"shape_attributes":{"name":"rect","x":698,"y":181,"width":85,"height":175},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011438.jpg52200":{"filename":"./images/00011438.jpg","size":"52200","regions":[{"shape_attributes":{"name":"rect","x":257,"y":116,"width":119,"height":150},"region_attributes":{"track":320}},{"shape_attributes":{"name":"rect","x":695,"y":167,"width":103,"height":192},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011439.jpg53849":{"filename":"./images/00011439.jpg","size":"53849","regions":[{"shape_attributes":{"name":"rect","x":243,"y":109,"width":119,"height":168},"region_attributes":{"track":320}},{"shape_attributes":{"name":"rect","x":701,"y":151,"width":118,"height":210},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011440.jpg53321":{"filename":"./images/00011440.jpg","size":"53321","regions":[{"shape_attributes":{"name":"rect","x":244,"y":112,"width":102,"height":159},"region_attributes":{"track":320}},{"shape_attributes":{"name":"rect","x":707,"y":170,"width":79,"height":178},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011441.jpg54872":{"filename":"./images/00011441.jpg","size":"54872","regions":[{"shape_attributes":{"name":"rect","x":248,"y":108,"width":95,"height":158},"region_attributes":{"track":320}},{"shape_attributes":{"name":"rect","x":708,"y":160,"width":90,"height":207},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011442.jpg55330":{"filename":"./images/00011442.jpg","size":"55330","regions":[{"shape_attributes":{"name":"rect","x":224,"y":109,"width":118,"height":168},"region_attributes":{"track":320}},{"shape_attributes":{"name":"rect","x":702,"y":175,"width":97,"height":178},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011443.jpg56118":{"filename":"./images/00011443.jpg","size":"56118","regions":[{"shape_attributes":{"name":"rect","x":214,"y":120,"width":123,"height":150},"region_attributes":{"track":320}},{"shape_attributes":{"name":"rect","x":711,"y":163,"width":91,"height":202},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011444.jpg55257":{"filename":"./images/00011444.jpg","size":"55257","regions":[{"shape_attributes":{"name":"rect","x":235,"y":113,"width":103,"height":159},"region_attributes":{"track":320}},{"shape_attributes":{"name":"rect","x":712,"y":182,"width":84,"height":184},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011445.jpg56073":{"filename":"./images/00011445.jpg","size":"56073","regions":[{"shape_attributes":{"name":"rect","x":228,"y":122,"width":104,"height":163},"region_attributes":{"track":320}},{"shape_attributes":{"name":"rect","x":704,"y":190,"width":100,"height":188},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011446.jpg55240":{"filename":"./images/00011446.jpg","size":"55240","regions":[{"shape_attributes":{"name":"rect","x":232,"y":127,"width":106,"height":151},"region_attributes":{"track":320}},{"shape_attributes":{"name":"rect","x":711,"y":187,"width":88,"height":185},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011447.jpg55652":{"filename":"./images/00011447.jpg","size":"55652","regions":[{"shape_attributes":{"name":"rect","x":237,"y":127,"width":108,"height":166},"region_attributes":{"track":320}},{"shape_attributes":{"name":"rect","x":717,"y":193,"width":97,"height":183},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011448.jpg54113":{"filename":"./images/00011448.jpg","size":"54113","regions":[{"shape_attributes":{"name":"rect","x":246,"y":132,"width":106,"height":162},"region_attributes":{"track":320}},{"shape_attributes":{"name":"rect","x":733,"y":183,"width":82,"height":193},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011449.jpg55514":{"filename":"./images/00011449.jpg","size":"55514","regions":[{"shape_attributes":{"name":"rect","x":241,"y":139,"width":118,"height":170},"region_attributes":{"track":320}},{"shape_attributes":{"name":"rect","x":733,"y":182,"width":90,"height":192},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011450.jpg55651":{"filename":"./images/00011450.jpg","size":"55651","regions":[{"shape_attributes":{"name":"rect","x":255,"y":159,"width":100,"height":152},"region_attributes":{"track":320}},{"shape_attributes":{"name":"rect","x":741,"y":186,"width":86,"height":189},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011451.jpg56826":{"filename":"./images/00011451.jpg","size":"56826","regions":[{"shape_attributes":{"name":"rect","x":253,"y":159,"width":102,"height":148},"region_attributes":{"track":320}},{"shape_attributes":{"name":"rect","x":738,"y":206,"width":86,"height":170},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011452.jpg55734":{"filename":"./images/00011452.jpg","size":"55734","regions":[{"shape_attributes":{"name":"rect","x":263,"y":159,"width":105,"height":152},"region_attributes":{"track":320}},{"shape_attributes":{"name":"rect","x":734,"y":191,"width":105,"height":208},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011453.jpg57083":{"filename":"./images/00011453.jpg","size":"57083","regions":[{"shape_attributes":{"name":"rect","x":266,"y":164,"width":100,"height":144},"region_attributes":{"track":320}},{"shape_attributes":{"name":"rect","x":735,"y":200,"width":96,"height":186},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011454.jpg55829":{"filename":"./images/00011454.jpg","size":"55829","regions":[{"shape_attributes":{"name":"rect","x":248,"y":169,"width":121,"height":147},"region_attributes":{"track":320}},{"shape_attributes":{"name":"rect","x":728,"y":215,"width":85,"height":164},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011455.jpg56790":{"filename":"./images/00011455.jpg","size":"56790","regions":[{"shape_attributes":{"name":"rect","x":254,"y":162,"width":105,"height":152},"region_attributes":{"track":320}},{"shape_attributes":{"name":"rect","x":721,"y":200,"width":90,"height":192},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011456.jpg55982":{"filename":"./images/00011456.jpg","size":"55982","regions":[{"shape_attributes":{"name":"rect","x":252,"y":163,"width":104,"height":151},"region_attributes":{"track":320}},{"shape_attributes":{"name":"rect","x":710,"y":202,"width":111,"height":183},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011457.jpg56828":{"filename":"./images/00011457.jpg","size":"56828","regions":[{"shape_attributes":{"name":"rect","x":251,"y":160,"width":104,"height":152},"region_attributes":{"track":320}},{"shape_attributes":{"name":"rect","x":711,"y":210,"width":109,"height":177},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011458.jpg55868":{"filename":"./images/00011458.jpg","size":"55868","regions":[{"shape_attributes":{"name":"rect","x":251,"y":160,"width":104,"height":150},"region_attributes":{"track":320}},{"shape_attributes":{"name":"rect","x":720,"y":206,"width":94,"height":184},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011459.jpg57282":{"filename":"./images/00011459.jpg","size":"57282","regions":[{"shape_attributes":{"name":"rect","x":247,"y":148,"width":110,"height":163},"region_attributes":{"track":320}},{"shape_attributes":{"name":"rect","x":717,"y":199,"width":94,"height":186},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011460.jpg58468":{"filename":"./images/00011460.jpg","size":"58468","regions":[{"shape_attributes":{"name":"rect","x":243,"y":158,"width":105,"height":154},"region_attributes":{"track":320}},{"shape_attributes":{"name":"rect","x":714,"y":198,"width":98,"height":198},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011461.jpg57293":{"filename":"./images/00011461.jpg","size":"57293","regions":[{"shape_attributes":{"name":"rect","x":238,"y":158,"width":104,"height":149},"region_attributes":{"track":320}},{"shape_attributes":{"name":"rect","x":713,"y":194,"width":101,"height":196},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011462.jpg58348":{"filename":"./images/00011462.jpg","size":"58348","regions":[{"shape_attributes":{"name":"rect","x":239,"y":151,"width":104,"height":152},"region_attributes":{"track":320}},{"shape_attributes":{"name":"rect","x":716,"y":214,"width":103,"height":166},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011463.jpg58826":{"filename":"./images/00011463.jpg","size":"58826","regions":[{"shape_attributes":{"name":"rect","x":231,"y":155,"width":100,"height":151},"region_attributes":{"track":320}},{"shape_attributes":{"name":"rect","x":710,"y":207,"width":98,"height":188},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011464.jpg58017":{"filename":"./images/00011464.jpg","size":"58017","regions":[{"shape_attributes":{"name":"rect","x":236,"y":145,"width":101,"height":155},"region_attributes":{"track":320}},{"shape_attributes":{"name":"rect","x":704,"y":231,"width":111,"height":167},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011465.jpg59047":{"filename":"./images/00011465.jpg","size":"59047","regions":[{"shape_attributes":{"name":"rect","x":230,"y":144,"width":104,"height":160},"region_attributes":{"track":320}},{"shape_attributes":{"name":"rect","x":714,"y":232,"width":118,"height":177},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011466.jpg58556":{"filename":"./images/00011466.jpg","size":"58556","regions":[{"shape_attributes":{"name":"rect","x":231,"y":147,"width":95,"height":159},"region_attributes":{"track":320}},{"shape_attributes":{"name":"rect","x":721,"y":247,"width":128,"height":169},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011467.jpg60265":{"filename":"./images/00011467.jpg","size":"60265","regions":[{"shape_attributes":{"name":"rect","x":224,"y":147,"width":101,"height":153},"region_attributes":{"track":320}},{"shape_attributes":{"name":"rect","x":711,"y":241,"width":143,"height":186},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011468.jpg59657":{"filename":"./images/00011468.jpg","size":"59657","regions":[{"shape_attributes":{"name":"rect","x":220,"y":144,"width":107,"height":165},"region_attributes":{"track":320}},{"shape_attributes":{"name":"rect","x":707,"y":231,"width":129,"height":194},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011469.jpg61018":{"filename":"./images/00011469.jpg","size":"61018","regions":[{"shape_attributes":{"name":"rect","x":219,"y":149,"width":103,"height":158},"region_attributes":{"track":320}},{"shape_attributes":{"name":"rect","x":719,"y":235,"width":131,"height":179},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011470.jpg60129":{"filename":"./images/00011470.jpg","size":"60129","regions":[{"shape_attributes":{"name":"rect","x":216,"y":144,"width":108,"height":171},"region_attributes":{"track":320}},{"shape_attributes":{"name":"rect","x":733,"y":234,"width":112,"height":189},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011471.jpg61161":{"filename":"./images/00011471.jpg","size":"61161","regions":[{"shape_attributes":{"name":"rect","x":218,"y":141,"width":108,"height":176},"region_attributes":{"track":320}},{"shape_attributes":{"name":"rect","x":728,"y":218,"width":121,"height":192},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011472.jpg61608":{"filename":"./images/00011472.jpg","size":"61608","regions":[{"shape_attributes":{"name":"rect","x":225,"y":140,"width":94,"height":176},"region_attributes":{"track":320}},{"shape_attributes":{"name":"rect","x":730,"y":215,"width":119,"height":186},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011473.jpg59941":{"filename":"./images/00011473.jpg","size":"59941","regions":[{"shape_attributes":{"name":"rect","x":226,"y":137,"width":96,"height":178},"region_attributes":{"track":320}},{"shape_attributes":{"name":"rect","x":734,"y":208,"width":103,"height":191},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011474.jpg61563":{"filename":"./images/00011474.jpg","size":"61563","regions":[{"shape_attributes":{"name":"rect","x":224,"y":151,"width":105,"height":157},"region_attributes":{"track":320}},{"shape_attributes":{"name":"rect","x":740,"y":200,"width":112,"height":197},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011475.jpg60841":{"filename":"./images/00011475.jpg","size":"60841","regions":[{"shape_attributes":{"name":"rect","x":234,"y":146,"width":98,"height":165},"region_attributes":{"track":320}},{"shape_attributes":{"name":"rect","x":749,"y":202,"width":116,"height":186},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011476.jpg62256":{"filename":"./images/00011476.jpg","size":"62256","regions":[{"shape_attributes":{"name":"rect","x":238,"y":138,"width":94,"height":177},"region_attributes":{"track":320}},{"shape_attributes":{"name":"rect","x":759,"y":211,"width":113,"height":180},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011477.jpg61956":{"filename":"./images/00011477.jpg","size":"61956","regions":[{"shape_attributes":{"name":"rect","x":247,"y":143,"width":86,"height":173},"region_attributes":{"track":320}},{"shape_attributes":{"name":"rect","x":753,"y":214,"width":111,"height":178},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011478.jpg62956":{"filename":"./images/00011478.jpg","size":"62956","regions":[{"shape_attributes":{"name":"rect","x":249,"y":150,"width":82,"height":162},"region_attributes":{"track":320}},{"shape_attributes":{"name":"rect","x":762,"y":198,"width":107,"height":195},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011479.jpg61421":{"filename":"./images/00011479.jpg","size":"61421","regions":[{"shape_attributes":{"name":"rect","x":250,"y":140,"width":85,"height":169},"region_attributes":{"track":320}},{"shape_attributes":{"name":"rect","x":759,"y":205,"width":108,"height":187},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011480.jpg62348":{"filename":"./images/00011480.jpg","size":"62348","regions":[{"shape_attributes":{"name":"rect","x":260,"y":133,"width":88,"height":178},"region_attributes":{"track":320}},{"shape_attributes":{"name":"rect","x":757,"y":194,"width":118,"height":198},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011481.jpg60629":{"filename":"./images/00011481.jpg","size":"60629","regions":[{"shape_attributes":{"name":"rect","x":261,"y":134,"width":85,"height":181},"region_attributes":{"track":320}},{"shape_attributes":{"name":"rect","x":768,"y":186,"width":108,"height":207},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011482.jpg62022":{"filename":"./images/00011482.jpg","size":"62022","regions":[{"shape_attributes":{"name":"rect","x":265,"y":146,"width":82,"height":157},"region_attributes":{"track":320}},{"shape_attributes":{"name":"rect","x":773,"y":188,"width":109,"height":208},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011483.jpg61717":{"filename":"./images/00011483.jpg","size":"61717","regions":[{"shape_attributes":{"name":"rect","x":268,"y":145,"width":80,"height":170},"region_attributes":{"track":320}},{"shape_attributes":{"name":"rect","x":774,"y":202,"width":108,"height":179},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011484.jpg63135":{"filename":"./images/00011484.jpg","size":"63135","regions":[{"shape_attributes":{"name":"rect","x":259,"y":146,"width":90,"height":175},"region_attributes":{"track":320}},{"shape_attributes":{"name":"rect","x":781,"y":193,"width":99,"height":195},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011485.jpg61778":{"filename":"./images/00011485.jpg","size":"61778","regions":[{"shape_attributes":{"name":"rect","x":257,"y":144,"width":82,"height":177},"region_attributes":{"track":320}},{"shape_attributes":{"name":"rect","x":773,"y":196,"width":100,"height":191},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011486.jpg62996":{"filename":"./images/00011486.jpg","size":"62996","regions":[{"shape_attributes":{"name":"rect","x":255,"y":150,"width":90,"height":167},"region_attributes":{"track":320}},{"shape_attributes":{"name":"rect","x":764,"y":198,"width":106,"height":192},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011487.jpg61782":{"filename":"./images/00011487.jpg","size":"61782","regions":[{"shape_attributes":{"name":"rect","x":255,"y":130,"width":92,"height":181},"region_attributes":{"track":320}},{"shape_attributes":{"name":"rect","x":764,"y":194,"width":108,"height":201},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011488.jpg62705":{"filename":"./images/00011488.jpg","size":"62705","regions":[{"shape_attributes":{"name":"rect","x":251,"y":140,"width":94,"height":167},"region_attributes":{"track":320}},{"shape_attributes":{"name":"rect","x":762,"y":195,"width":105,"height":195},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011489.jpg61805":{"filename":"./images/00011489.jpg","size":"61805","regions":[{"shape_attributes":{"name":"rect","x":239,"y":142,"width":98,"height":164},"region_attributes":{"track":320}},{"shape_attributes":{"name":"rect","x":757,"y":189,"width":111,"height":202},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011490.jpg63309":{"filename":"./images/00011490.jpg","size":"63309","regions":[{"shape_attributes":{"name":"rect","x":247,"y":137,"width":85,"height":169},"region_attributes":{"track":320}},{"shape_attributes":{"name":"rect","x":759,"y":184,"width":111,"height":203},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011491.jpg61639":{"filename":"./images/00011491.jpg","size":"61639","regions":[{"shape_attributes":{"name":"rect","x":240,"y":131,"width":90,"height":180},"region_attributes":{"track":320}},{"shape_attributes":{"name":"rect","x":759,"y":182,"width":108,"height":197},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011492.jpg62831":{"filename":"./images/00011492.jpg","size":"62831","regions":[{"shape_attributes":{"name":"rect","x":240,"y":142,"width":90,"height":170},"region_attributes":{"track":320}},{"shape_attributes":{"name":"rect","x":754,"y":183,"width":111,"height":194},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011493.jpg60575":{"filename":"./images/00011493.jpg","size":"60575","regions":[{"shape_attributes":{"name":"rect","x":240,"y":134,"width":89,"height":179},"region_attributes":{"track":320}},{"shape_attributes":{"name":"rect","x":748,"y":176,"width":119,"height":209},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011494.jpg62322":{"filename":"./images/00011494.jpg","size":"62322","regions":[{"shape_attributes":{"name":"rect","x":234,"y":123,"width":101,"height":189},"region_attributes":{"track":320}},{"shape_attributes":{"name":"rect","x":748,"y":188,"width":118,"height":184},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011495.jpg61005":{"filename":"./images/00011495.jpg","size":"61005","regions":[{"shape_attributes":{"name":"rect","x":229,"y":125,"width":96,"height":194},"region_attributes":{"track":320}},{"shape_attributes":{"name":"rect","x":750,"y":191,"width":123,"height":178},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011496.jpg62504":{"filename":"./images/00011496.jpg","size":"62504","regions":[{"shape_attributes":{"name":"rect","x":225,"y":124,"width":111,"height":202},"region_attributes":{"track":320}},{"shape_attributes":{"name":"rect","x":739,"y":176,"width":124,"height":209},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011497.jpg61127":{"filename":"./images/00011497.jpg","size":"61127","regions":[{"shape_attributes":{"name":"rect","x":227,"y":123,"width":103,"height":184},"region_attributes":{"track":320}},{"shape_attributes":{"name":"rect","x":742,"y":189,"width":118,"height":177},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011498.jpg62326":{"filename":"./images/00011498.jpg","size":"62326","regions":[{"shape_attributes":{"name":"rect","x":230,"y":125,"width":96,"height":186},"region_attributes":{"track":320}},{"shape_attributes":{"name":"rect","x":743,"y":188,"width":116,"height":175},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011499.jpg61403":{"filename":"./images/00011499.jpg","size":"61403","regions":[{"shape_attributes":{"name":"rect","x":231,"y":116,"width":95,"height":201},"region_attributes":{"track":320}},{"shape_attributes":{"name":"rect","x":741,"y":177,"width":120,"height":201},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011500.jpg62696":{"filename":"./images/00011500.jpg","size":"62696","regions":[{"shape_attributes":{"name":"rect","x":239,"y":131,"width":89,"height":183},"region_attributes":{"track":320}},{"shape_attributes":{"name":"rect","x":740,"y":188,"width":121,"height":180},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011501.jpg62532":{"filename":"./images/00011501.jpg","size":"62532","regions":[{"shape_attributes":{"name":"rect","x":249,"y":146,"width":79,"height":165},"region_attributes":{"track":320}},{"shape_attributes":{"name":"rect","x":733,"y":179,"width":116,"height":202},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011502.jpg63640":{"filename":"./images/00011502.jpg","size":"63640","regions":[{"shape_attributes":{"name":"rect","x":237,"y":141,"width":80,"height":180},"region_attributes":{"track":320}},{"shape_attributes":{"name":"rect","x":740,"y":184,"width":120,"height":197},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011503.jpg61583":{"filename":"./images/00011503.jpg","size":"61583","regions":[{"shape_attributes":{"name":"rect","x":247,"y":140,"width":78,"height":181},"region_attributes":{"track":320}},{"shape_attributes":{"name":"rect","x":728,"y":187,"width":135,"height":193},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011504.jpg63424":{"filename":"./images/00011504.jpg","size":"63424","regions":[{"shape_attributes":{"name":"rect","x":249,"y":130,"width":77,"height":185},"region_attributes":{"track":320}},{"shape_attributes":{"name":"rect","x":728,"y":191,"width":134,"height":187},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011505.jpg62591":{"filename":"./images/00011505.jpg","size":"62591","regions":[{"shape_attributes":{"name":"rect","x":255,"y":141,"width":65,"height":154},"region_attributes":{"track":320}},{"shape_attributes":{"name":"rect","x":740,"y":178,"width":126,"height":201},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011506.jpg63429":{"filename":"./images/00011506.jpg","size":"63429","regions":[{"shape_attributes":{"name":"rect","x":228,"y":145,"width":87,"height":167},"region_attributes":{"track":320}},{"shape_attributes":{"name":"rect","x":738,"y":192,"width":119,"height":174},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011507.jpg62169":{"filename":"./images/00011507.jpg","size":"62169","regions":[{"shape_attributes":{"name":"rect","x":227,"y":148,"width":90,"height":165},"region_attributes":{"track":320}},{"shape_attributes":{"name":"rect","x":727,"y":182,"width":138,"height":192},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011508.jpg63599":{"filename":"./images/00011508.jpg","size":"63599","regions":[{"shape_attributes":{"name":"rect","x":227,"y":150,"width":92,"height":165},"region_attributes":{"track":320}},{"shape_attributes":{"name":"rect","x":725,"y":186,"width":136,"height":186},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011509.jpg61722":{"filename":"./images/00011509.jpg","size":"61722","regions":[{"shape_attributes":{"name":"rect","x":226,"y":153,"width":95,"height":163},"region_attributes":{"track":320}},{"shape_attributes":{"name":"rect","x":726,"y":179,"width":140,"height":190},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011510.jpg62612":{"filename":"./images/00011510.jpg","size":"62612","regions":[{"shape_attributes":{"name":"rect","x":225,"y":155,"width":98,"height":163},"region_attributes":{"track":320}},{"shape_attributes":{"name":"rect","x":722,"y":180,"width":136,"height":184},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011511.jpg61334":{"filename":"./images/00011511.jpg","size":"61334","regions":[{"shape_attributes":{"name":"rect","x":225,"y":158,"width":100,"height":161},"region_attributes":{"track":320}},{"shape_attributes":{"name":"rect","x":723,"y":185,"width":132,"height":178},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011512.jpg61872":{"filename":"./images/00011512.jpg","size":"61872","regions":[{"shape_attributes":{"name":"rect","x":224,"y":161,"width":102,"height":159},"region_attributes":{"track":320}},{"shape_attributes":{"name":"rect","x":731,"y":177,"width":114,"height":195},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011513.jpg60793":{"filename":"./images/00011513.jpg","size":"60793","regions":[{"shape_attributes":{"name":"rect","x":223,"y":163,"width":105,"height":159},"region_attributes":{"track":320}},{"shape_attributes":{"name":"rect","x":730,"y":179,"width":127,"height":179},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011514.jpg61923":{"filename":"./images/00011514.jpg","size":"61923","regions":[{"shape_attributes":{"name":"rect","x":222,"y":166,"width":108,"height":157},"region_attributes":{"track":320}},{"shape_attributes":{"name":"rect","x":727,"y":178,"width":127,"height":178},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011515.jpg60226":{"filename":"./images/00011515.jpg","size":"60226","regions":[{"shape_attributes":{"name":"rect","x":222,"y":168,"width":110,"height":157},"region_attributes":{"track":320}},{"shape_attributes":{"name":"rect","x":728,"y":179,"width":117,"height":182},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011516.jpg61350":{"filename":"./images/00011516.jpg","size":"61350","regions":[{"shape_attributes":{"name":"rect","x":221,"y":171,"width":113,"height":155},"region_attributes":{"track":320}},{"shape_attributes":{"name":"rect","x":712,"y":178,"width":136,"height":183},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011517.jpg59581":{"filename":"./images/00011517.jpg","size":"59581","regions":[{"shape_attributes":{"name":"rect","x":221,"y":175,"width":122,"height":150},"region_attributes":{"track":320}},{"shape_attributes":{"name":"rect","x":710,"y":174,"width":133,"height":180},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011518.jpg60949":{"filename":"./images/00011518.jpg","size":"60949","regions":[{"shape_attributes":{"name":"rect","x":233,"y":172,"width":99,"height":152},"region_attributes":{"track":320}},{"shape_attributes":{"name":"rect","x":706,"y":181,"width":134,"height":174},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011519.jpg59758":{"filename":"./images/00011519.jpg","size":"59758","regions":[{"shape_attributes":{"name":"rect","x":246,"y":170,"width":91,"height":150},"region_attributes":{"track":320}},{"shape_attributes":{"name":"rect","x":713,"y":181,"width":129,"height":182},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011520.jpg61229":{"filename":"./images/00011520.jpg","size":"61229","regions":[{"shape_attributes":{"name":"rect","x":253,"y":182,"width":89,"height":144},"region_attributes":{"track":320}},{"shape_attributes":{"name":"rect","x":706,"y":167,"width":129,"height":179},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011521.jpg60126":{"filename":"./images/00011521.jpg","size":"60126","regions":[{"shape_attributes":{"name":"rect","x":251,"y":185,"width":95,"height":171},"region_attributes":{"track":320}},{"shape_attributes":{"name":"rect","x":694,"y":177,"width":136,"height":177},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011522.jpg61658":{"filename":"./images/00011522.jpg","size":"61658","regions":[{"shape_attributes":{"name":"rect","x":250,"y":190,"width":104,"height":153},"region_attributes":{"track":320}},{"shape_attributes":{"name":"rect","x":693,"y":174,"width":138,"height":180},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011523.jpg61004":{"filename":"./images/00011523.jpg","size":"61004","regions":[{"shape_attributes":{"name":"rect","x":252,"y":204,"width":110,"height":142},"region_attributes":{"track":320}},{"shape_attributes":{"name":"rect","x":701,"y":172,"width":127,"height":186},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011524.jpg62032":{"filename":"./images/00011524.jpg","size":"62032","regions":[{"shape_attributes":{"name":"rect","x":267,"y":210,"width":100,"height":108},"region_attributes":{"track":320}},{"shape_attributes":{"name":"rect","x":687,"y":169,"width":143,"height":187},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011525.jpg61257":{"filename":"./images/00011525.jpg","size":"61257","regions":[{"shape_attributes":{"name":"rect","x":247,"y":219,"width":129,"height":125},"region_attributes":{"track":320}},{"shape_attributes":{"name":"rect","x":683,"y":161,"width":145,"height":194},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011526.jpg62304":{"filename":"./images/00011526.jpg","size":"62304","regions":[{"shape_attributes":{"name":"rect","x":247,"y":213,"width":124,"height":133},"region_attributes":{"track":320}},{"shape_attributes":{"name":"rect","x":688,"y":158,"width":120,"height":194},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011527.jpg61015":{"filename":"./images/00011527.jpg","size":"61015","regions":[{"shape_attributes":{"name":"rect","x":249,"y":215,"width":121,"height":146},"region_attributes":{"track":320}},{"shape_attributes":{"name":"rect","x":692,"y":166,"width":131,"height":173},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011528.jpg62286":{"filename":"./images/00011528.jpg","size":"62286","regions":[{"shape_attributes":{"name":"rect","x":263,"y":224,"width":115,"height":127},"region_attributes":{"track":320}},{"shape_attributes":{"name":"rect","x":693,"y":159,"width":117,"height":186},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011529.jpg60930":{"filename":"./images/00011529.jpg","size":"60930","regions":[{"shape_attributes":{"name":"rect","x":276,"y":233,"width":109,"height":108},"region_attributes":{"track":320}},{"shape_attributes":{"name":"rect","x":669,"y":157,"width":150,"height":192},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011530.jpg62217":{"filename":"./images/00011530.jpg","size":"62217","regions":[{"shape_attributes":{"name":"rect","x":268,"y":241,"width":120,"height":106},"region_attributes":{"track":320}},{"shape_attributes":{"name":"rect","x":684,"y":157,"width":118,"height":193},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011531.jpg62178":{"filename":"./images/00011531.jpg","size":"62178","regions":[{"shape_attributes":{"name":"rect","x":265,"y":231,"width":127,"height":144},"region_attributes":{"track":320}},{"shape_attributes":{"name":"rect","x":678,"y":159,"width":135,"height":189},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011532.jpg63723":{"filename":"./images/00011532.jpg","size":"63723","regions":[{"shape_attributes":{"name":"rect","x":264,"y":232,"width":131,"height":149},"region_attributes":{"track":320}},{"shape_attributes":{"name":"rect","x":676,"y":167,"width":134,"height":175},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011533.jpg62507":{"filename":"./images/00011533.jpg","size":"62507","regions":[{"shape_attributes":{"name":"rect","x":262,"y":232,"width":136,"height":154},"region_attributes":{"track":320}},{"shape_attributes":{"name":"rect","x":673,"y":165,"width":134,"height":179},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011534.jpg63483":{"filename":"./images/00011534.jpg","size":"63483","regions":[{"shape_attributes":{"name":"rect","x":261,"y":233,"width":139,"height":159},"region_attributes":{"track":320}},{"shape_attributes":{"name":"rect","x":659,"y":165,"width":147,"height":188},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011535.jpg62210":{"filename":"./images/00011535.jpg","size":"62210","regions":[{"shape_attributes":{"name":"rect","x":260,"y":233,"width":143,"height":165},"region_attributes":{"track":320}},{"shape_attributes":{"name":"rect","x":657,"y":173,"width":144,"height":180},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011536.jpg62913":{"filename":"./images/00011536.jpg","size":"62913","regions":[{"shape_attributes":{"name":"rect","x":258,"y":234,"width":148,"height":169},"region_attributes":{"track":320}},{"shape_attributes":{"name":"rect","x":654,"y":173,"width":143,"height":186},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011537.jpg61275":{"filename":"./images/00011537.jpg","size":"61275","regions":[{"shape_attributes":{"name":"rect","x":257,"y":234,"width":152,"height":175},"region_attributes":{"track":320}},{"shape_attributes":{"name":"rect","x":663,"y":177,"width":130,"height":179},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011538.jpg62679":{"filename":"./images/00011538.jpg","size":"62679","regions":[{"shape_attributes":{"name":"rect","x":255,"y":235,"width":156,"height":179},"region_attributes":{"track":320}},{"shape_attributes":{"name":"rect","x":660,"y":179,"width":129,"height":177},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011539.jpg60617":{"filename":"./images/00011539.jpg","size":"60617","regions":[{"shape_attributes":{"name":"rect","x":254,"y":235,"width":160,"height":185},"region_attributes":{"track":320}},{"shape_attributes":{"name":"rect","x":657,"y":172,"width":129,"height":181},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011540.jpg61810":{"filename":"./images/00011540.jpg","size":"61810","regions":[{"shape_attributes":{"name":"rect","x":264,"y":209,"width":163,"height":201},"region_attributes":{"track":320}},{"shape_attributes":{"name":"rect","x":650,"y":170,"width":133,"height":184},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011541.jpg60117":{"filename":"./images/00011541.jpg","size":"60117","regions":[{"shape_attributes":{"name":"rect","x":257,"y":217,"width":157,"height":190},"region_attributes":{"track":320}},{"shape_attributes":{"name":"rect","x":642,"y":179,"width":136,"height":166},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011542.jpg61786":{"filename":"./images/00011542.jpg","size":"61786","regions":[{"shape_attributes":{"name":"rect","x":260,"y":208,"width":153,"height":202},"region_attributes":{"track":320}},{"shape_attributes":{"name":"rect","x":653,"y":174,"width":132,"height":178},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011543.jpg60778":{"filename":"./images/00011543.jpg","size":"60778","regions":[{"shape_attributes":{"name":"rect","x":263,"y":199,"width":149,"height":213},"region_attributes":{"track":320}},{"shape_attributes":{"name":"rect","x":646,"y":176,"width":143,"height":186},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011544.jpg62345":{"filename":"./images/00011544.jpg","size":"62345","regions":[{"shape_attributes":{"name":"rect","x":276,"y":186,"width":139,"height":198},"region_attributes":{"track":320}},{"shape_attributes":{"name":"rect","x":647,"y":174,"width":139,"height":187},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011545.jpg60974":{"filename":"./images/00011545.jpg","size":"60974","regions":[{"shape_attributes":{"name":"rect","x":271,"y":194,"width":137,"height":183},"region_attributes":{"track":320}},{"shape_attributes":{"name":"rect","x":643,"y":175,"width":142,"height":191},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011546.jpg62738":{"filename":"./images/00011546.jpg","size":"62738","regions":[{"shape_attributes":{"name":"rect","x":284,"y":185,"width":124,"height":181},"region_attributes":{"track":320}},{"shape_attributes":{"name":"rect","x":645,"y":184,"width":139,"height":180},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011547.jpg63304":{"filename":"./images/00011547.jpg","size":"63304","regions":[{"shape_attributes":{"name":"rect","x":297,"y":175,"width":112,"height":179},"region_attributes":{"track":320}},{"shape_attributes":{"name":"rect","x":636,"y":178,"width":151,"height":186},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011548.jpg61125":{"filename":"./images/00011548.jpg","size":"61125","regions":[{"shape_attributes":{"name":"rect","x":310,"y":166,"width":99,"height":177},"region_attributes":{"track":320}},{"shape_attributes":{"name":"rect","x":643,"y":183,"width":132,"height":174},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011549.jpg62737":{"filename":"./images/00011549.jpg","size":"62737","regions":[{"shape_attributes":{"name":"rect","x":640,"y":180,"width":125,"height":183},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011550.jpg60996":{"filename":"./images/00011550.jpg","size":"60996","regions":[{"shape_attributes":{"name":"rect","x":635,"y":179,"width":136,"height":176},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011551.jpg62201":{"filename":"./images/00011551.jpg","size":"62201","regions":[{"shape_attributes":{"name":"rect","x":630,"y":182,"width":135,"height":175},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011552.jpg59225":{"filename":"./images/00011552.jpg","size":"59225","regions":[{"shape_attributes":{"name":"rect","x":621,"y":178,"width":140,"height":181},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011553.jpg59979":{"filename":"./images/00011553.jpg","size":"59979","regions":[{"shape_attributes":{"name":"rect","x":612,"y":168,"width":145,"height":182},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011554.jpg60872":{"filename":"./images/00011554.jpg","size":"60872","regions":[{"shape_attributes":{"name":"rect","x":602,"y":161,"width":144,"height":198},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011555.jpg58285":{"filename":"./images/00011555.jpg","size":"58285","regions":[{"shape_attributes":{"name":"rect","x":592,"y":170,"width":149,"height":187},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011556.jpg58837":{"filename":"./images/00011556.jpg","size":"58837","regions":[{"shape_attributes":{"name":"rect","x":589,"y":165,"width":153,"height":196},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011557.jpg59190":{"filename":"./images/00011557.jpg","size":"59190","regions":[{"shape_attributes":{"name":"rect","x":589,"y":175,"width":133,"height":181},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011558.jpg57236":{"filename":"./images/00011558.jpg","size":"57236","regions":[{"shape_attributes":{"name":"rect","x":579,"y":164,"width":142,"height":198},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011559.jpg57689":{"filename":"./images/00011559.jpg","size":"57689","regions":[{"shape_attributes":{"name":"rect","x":572,"y":162,"width":141,"height":196},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011560.jpg58484":{"filename":"./images/00011560.jpg","size":"58484","regions":[{"shape_attributes":{"name":"rect","x":565,"y":160,"width":132,"height":195},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011561.jpg57511":{"filename":"./images/00011561.jpg","size":"57511","regions":[{"shape_attributes":{"name":"rect","x":560,"y":166,"width":139,"height":186},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011562.jpg58233":{"filename":"./images/00011562.jpg","size":"58233","regions":[{"shape_attributes":{"name":"rect","x":555,"y":159,"width":140,"height":188},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011563.jpg58923":{"filename":"./images/00011563.jpg","size":"58923","regions":[{"shape_attributes":{"name":"rect","x":550,"y":157,"width":138,"height":197},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011564.jpg58158":{"filename":"./images/00011564.jpg","size":"58158","regions":[{"shape_attributes":{"name":"rect","x":547,"y":148,"width":142,"height":201},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011565.jpg59121":{"filename":"./images/00011565.jpg","size":"59121","regions":[{"shape_attributes":{"name":"rect","x":544,"y":160,"width":142,"height":179},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011566.jpg60243":{"filename":"./images/00011566.jpg","size":"60243","regions":[{"shape_attributes":{"name":"rect","x":541,"y":155,"width":144,"height":191},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011567.jpg59476":{"filename":"./images/00011567.jpg","size":"59476","regions":[{"shape_attributes":{"name":"rect","x":539,"y":156,"width":144,"height":188},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011568.jpg60355":{"filename":"./images/00011568.jpg","size":"60355","regions":[{"shape_attributes":{"name":"rect","x":532,"y":146,"width":146,"height":201},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011569.jpg61329":{"filename":"./images/00011569.jpg","size":"61329","regions":[{"shape_attributes":{"name":"rect","x":529,"y":144,"width":144,"height":201},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011570.jpg60546":{"filename":"./images/00011570.jpg","size":"60546","regions":[{"shape_attributes":{"name":"rect","x":526,"y":141,"width":151,"height":194},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011571.jpg61758":{"filename":"./images/00011571.jpg","size":"61758","regions":[{"shape_attributes":{"name":"rect","x":528,"y":150,"width":143,"height":201},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011572.jpg62828":{"filename":"./images/00011572.jpg","size":"62828","regions":[{"shape_attributes":{"name":"rect","x":527,"y":147,"width":143,"height":207},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011573.jpg62064":{"filename":"./images/00011573.jpg","size":"62064","regions":[{"shape_attributes":{"name":"rect","x":524,"y":138,"width":147,"height":215},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011574.jpg62998":{"filename":"./images/00011574.jpg","size":"62998","regions":[{"shape_attributes":{"name":"rect","x":519,"y":147,"width":148,"height":205},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011575.jpg64095":{"filename":"./images/00011575.jpg","size":"64095","regions":[{"shape_attributes":{"name":"rect","x":521,"y":143,"width":148,"height":210},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011576.jpg62617":{"filename":"./images/00011576.jpg","size":"62617","regions":[{"shape_attributes":{"name":"rect","x":523,"y":148,"width":144,"height":204},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011577.jpg63678":{"filename":"./images/00011577.jpg","size":"63678","regions":[{"shape_attributes":{"name":"rect","x":522,"y":147,"width":144,"height":208},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011578.jpg63507":{"filename":"./images/00011578.jpg","size":"63507","regions":[{"shape_attributes":{"name":"rect","x":518,"y":152,"width":143,"height":203},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011579.jpg64721":{"filename":"./images/00011579.jpg","size":"64721","regions":[{"shape_attributes":{"name":"rect","x":515,"y":144,"width":150,"height":207},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011580.jpg63846":{"filename":"./images/00011580.jpg","size":"63846","regions":[{"shape_attributes":{"name":"rect","x":513,"y":145,"width":152,"height":214},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011581.jpg64080":{"filename":"./images/00011581.jpg","size":"64080","regions":[{"shape_attributes":{"name":"rect","x":513,"y":154,"width":145,"height":210},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011582.jpg63893":{"filename":"./images/00011582.jpg","size":"63893","regions":[{"shape_attributes":{"name":"rect","x":514,"y":150,"width":144,"height":210},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011583.jpg65344":{"filename":"./images/00011583.jpg","size":"65344","regions":[{"shape_attributes":{"name":"rect","x":512,"y":150,"width":146,"height":210},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011584.jpg64071":{"filename":"./images/00011584.jpg","size":"64071","regions":[{"shape_attributes":{"name":"rect","x":511,"y":149,"width":145,"height":211},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011585.jpg64176":{"filename":"./images/00011585.jpg","size":"64176","regions":[{"shape_attributes":{"name":"rect","x":510,"y":149,"width":146,"height":210},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011586.jpg64642":{"filename":"./images/00011586.jpg","size":"64642","regions":[{"shape_attributes":{"name":"rect","x":506,"y":153,"width":152,"height":210},"region_attributes":{"track":321}}],"file_attributes":{"shot":123}},"./images/00011587.jpg64642":{"filename":"./images/00011587.jpg","size":"64642","regions":[{"shape_attributes":{"name":"rect","x":312,"y":108,"width":150,"height":177},"region_attributes":{"track":322}}],"file_attributes":{"shot":124}},"./images/00011588.jpg61599":{"filename":"./images/00011588.jpg","size":"61599","regions":[{"shape_attributes":{"name":"rect","x":308,"y":108,"width":152,"height":177},"region_attributes":{"track":322}}],"file_attributes":{"shot":124}},"./images/00011589.jpg62623":{"filename":"./images/00011589.jpg","size":"62623","regions":[{"shape_attributes":{"name":"rect","x":302,"y":97,"width":162,"height":185},"region_attributes":{"track":322}}],"file_attributes":{"shot":124}},"./images/00011590.jpg61157":{"filename":"./images/00011590.jpg","size":"61157","regions":[{"shape_attributes":{"name":"rect","x":309,"y":87,"width":141,"height":189},"region_attributes":{"track":322}}],"file_attributes":{"shot":124}},"./images/00011591.jpg64085":{"filename":"./images/00011591.jpg","size":"64085","regions":[{"shape_attributes":{"name":"rect","x":309,"y":94,"width":156,"height":193},"region_attributes":{"track":322}}],"file_attributes":{"shot":124}},"./images/00011592.jpg61538":{"filename":"./images/00011592.jpg","size":"61538","regions":[{"shape_attributes":{"name":"rect","x":314,"y":84,"width":146,"height":203},"region_attributes":{"track":322}}],"file_attributes":{"shot":124}},"./images/00011593.jpg62434":{"filename":"./images/00011593.jpg","size":"62434","regions":[{"shape_attributes":{"name":"rect","x":308,"y":101,"width":153,"height":186},"region_attributes":{"track":322}}],"file_attributes":{"shot":124}},"./images/00011594.jpg61740":{"filename":"./images/00011594.jpg","size":"61740","regions":[{"shape_attributes":{"name":"rect","x":315,"y":89,"width":142,"height":202},"region_attributes":{"track":322}}],"file_attributes":{"shot":124}},"./images/00011595.jpg64148":{"filename":"./images/00011595.jpg","size":"64148","regions":[{"shape_attributes":{"name":"rect","x":313,"y":82,"width":145,"height":206},"region_attributes":{"track":322}}],"file_attributes":{"shot":124}},"./images/00011596.jpg61180":{"filename":"./images/00011596.jpg","size":"61180","regions":[{"shape_attributes":{"name":"rect","x":304,"y":85,"width":145,"height":197},"region_attributes":{"track":322}}],"file_attributes":{"shot":124}},"./images/00011597.jpg61790":{"filename":"./images/00011597.jpg","size":"61790","regions":[{"shape_attributes":{"name":"rect","x":300,"y":98,"width":147,"height":179},"region_attributes":{"track":322}}],"file_attributes":{"shot":124}},"./images/00011598.jpg62172":{"filename":"./images/00011598.jpg","size":"62172","regions":[{"shape_attributes":{"name":"rect","x":311,"y":80,"width":142,"height":205},"region_attributes":{"track":322}}],"file_attributes":{"shot":124}},"./images/00011599.jpg63223":{"filename":"./images/00011599.jpg","size":"63223","regions":[{"shape_attributes":{"name":"rect","x":295,"y":93,"width":156,"height":183},"region_attributes":{"track":322}}],"file_attributes":{"shot":124}},"./images/00011600.jpg61225":{"filename":"./images/00011600.jpg","size":"61225","regions":[{"shape_attributes":{"name":"rect","x":296,"y":97,"width":148,"height":181},"region_attributes":{"track":322}}],"file_attributes":{"shot":124}},"./images/00011601.jpg61829":{"filename":"./images/00011601.jpg","size":"61829","regions":[{"shape_attributes":{"name":"rect","x":301,"y":78,"width":152,"height":201},"region_attributes":{"track":322}}],"file_attributes":{"shot":124}},"./images/00011602.jpg60700":{"filename":"./images/00011602.jpg","size":"60700","regions":[{"shape_attributes":{"name":"rect","x":303,"y":95,"width":151,"height":185},"region_attributes":{"track":322}},{"shape_attributes":{"name":"rect","x":0,"y":96,"width":57,"height":118},"region_attributes":{"track":324}}],"file_attributes":{"shot":124}},"./images/00011603.jpg61958":{"filename":"./images/00011603.jpg","size":"61958","regions":[{"shape_attributes":{"name":"rect","x":303,"y":88,"width":139,"height":192},"region_attributes":{"track":322}},{"shape_attributes":{"name":"rect","x":19,"y":94,"width":59,"height":119},"region_attributes":{"track":324}}],"file_attributes":{"shot":124}},"./images/00011604.jpg60655":{"filename":"./images/00011604.jpg","size":"60655","regions":[{"shape_attributes":{"name":"rect","x":302,"y":101,"width":137,"height":176},"region_attributes":{"track":322}},{"shape_attributes":{"name":"rect","x":37,"y":91,"width":62,"height":121},"region_attributes":{"track":324}}],"file_attributes":{"shot":124}},"./images/00011605.jpg60177":{"filename":"./images/00011605.jpg","size":"60177","regions":[{"shape_attributes":{"name":"rect","x":302,"y":102,"width":135,"height":177},"region_attributes":{"track":322}},{"shape_attributes":{"name":"rect","x":56,"y":89,"width":64,"height":122},"region_attributes":{"track":324}}],"file_attributes":{"shot":124}},"./images/00011606.jpg59378":{"filename":"./images/00011606.jpg","size":"59378","regions":[{"shape_attributes":{"name":"rect","x":295,"y":79,"width":146,"height":192},"region_attributes":{"track":322}},{"shape_attributes":{"name":"rect","x":74,"y":86,"width":67,"height":124},"region_attributes":{"track":324}}],"file_attributes":{"shot":124}},"./images/00011607.jpg60763":{"filename":"./images/00011607.jpg","size":"60763","regions":[{"shape_attributes":{"name":"rect","x":292,"y":76,"width":148,"height":196},"region_attributes":{"track":322}},{"shape_attributes":{"name":"rect","x":93,"y":84,"width":69,"height":125},"region_attributes":{"track":324}}],"file_attributes":{"shot":124}},"./images/00011608.jpg58497":{"filename":"./images/00011608.jpg","size":"58497","regions":[{"shape_attributes":{"name":"rect","x":288,"y":83,"width":158,"height":202},"region_attributes":{"track":322}},{"shape_attributes":{"name":"rect","x":111,"y":81,"width":72,"height":127},"region_attributes":{"track":324}}],"file_attributes":{"shot":124}},"./images/00011609.jpg58833":{"filename":"./images/00011609.jpg","size":"58833","regions":[{"shape_attributes":{"name":"rect","x":295,"y":85,"width":149,"height":198},"region_attributes":{"track":322}},{"shape_attributes":{"name":"rect","x":130,"y":87,"width":74,"height":119},"region_attributes":{"track":324}}],"file_attributes":{"shot":124}},"./images/00011610.jpg59947":{"filename":"./images/00011610.jpg","size":"59947","regions":[{"shape_attributes":{"name":"rect","x":283,"y":84,"width":157,"height":199},"region_attributes":{"track":322}},{"shape_attributes":{"name":"rect","x":149,"y":88,"width":80,"height":116},"region_attributes":{"track":324}}],"file_attributes":{"shot":124}},"./images/00011611.jpg57770":{"filename":"./images/00011611.jpg","size":"57770","regions":[{"shape_attributes":{"name":"rect","x":276,"y":99,"width":155,"height":194},"region_attributes":{"track":322}},{"shape_attributes":{"name":"rect","x":170,"y":84,"width":86,"height":129},"region_attributes":{"track":324}}],"file_attributes":{"shot":124}},"./images/00011612.jpg58686":{"filename":"./images/00011612.jpg","size":"58686","regions":[{"shape_attributes":{"name":"rect","x":275,"y":115,"width":148,"height":169},"region_attributes":{"track":322}},{"shape_attributes":{"name":"rect","x":188,"y":89,"width":75,"height":128},"region_attributes":{"track":324}}],"file_attributes":{"shot":124}},"./images/00011613.jpg57344":{"filename":"./images/00011613.jpg","size":"57344","regions":[{"shape_attributes":{"name":"rect","x":266,"y":117,"width":162,"height":189},"region_attributes":{"track":322}},{"shape_attributes":{"name":"rect","x":207,"y":90,"width":64,"height":123},"region_attributes":{"track":324}}],"file_attributes":{"shot":124}},"./images/00011614.jpg59015":{"filename":"./images/00011614.jpg","size":"59015","regions":[{"shape_attributes":{"name":"rect","x":270,"y":124,"width":152,"height":197},"region_attributes":{"track":322}}],"file_attributes":{"shot":124}},"./images/00011615.jpg60428":{"filename":"./images/00011615.jpg","size":"60428","regions":[{"shape_attributes":{"name":"rect","x":276,"y":150,"width":145,"height":162},"region_attributes":{"track":322}}],"file_attributes":{"shot":124}},"./images/00011616.jpg60109":{"filename":"./images/00011616.jpg","size":"60109","regions":[{"shape_attributes":{"name":"rect","x":272,"y":159,"width":135,"height":159},"region_attributes":{"track":322}}],"file_attributes":{"shot":124}},"./images/00011617.jpg60445":{"filename":"./images/00011617.jpg","size":"60445","regions":[{"shape_attributes":{"name":"rect","x":262,"y":145,"width":149,"height":171},"region_attributes":{"track":322}}],"file_attributes":{"shot":124}},"./images/00011618.jpg61294":{"filename":"./images/00011618.jpg","size":"61294","regions":[{"shape_attributes":{"name":"rect","x":275,"y":146,"width":141,"height":179},"region_attributes":{"track":322}}],"file_attributes":{"shot":124}},"./images/00011619.jpg59925":{"filename":"./images/00011619.jpg","size":"59925","regions":[{"shape_attributes":{"name":"rect","x":275,"y":148,"width":138,"height":177},"region_attributes":{"track":322}}],"file_attributes":{"shot":124}},"./images/00011620.jpg60224":{"filename":"./images/00011620.jpg","size":"60224","regions":[{"shape_attributes":{"name":"rect","x":276,"y":135,"width":142,"height":186},"region_attributes":{"track":322}}],"file_attributes":{"shot":124}},"./images/00011621.jpg60657":{"filename":"./images/00011621.jpg","size":"60657","regions":[{"shape_attributes":{"name":"rect","x":261,"y":148,"width":146,"height":173},"region_attributes":{"track":322}}],"file_attributes":{"shot":124}},"./images/00011622.jpg59880":{"filename":"./images/00011622.jpg","size":"59880","regions":[{"shape_attributes":{"name":"rect","x":268,"y":110,"width":148,"height":203},"region_attributes":{"track":322}}],"file_attributes":{"shot":124}},"./images/00011623.jpg60664":{"filename":"./images/00011623.jpg","size":"60664","regions":[{"shape_attributes":{"name":"rect","x":266,"y":102,"width":149,"height":211},"region_attributes":{"track":322}}],"file_attributes":{"shot":124}},"./images/00011624.jpg59219":{"filename":"./images/00011624.jpg","size":"59219","regions":[{"shape_attributes":{"name":"rect","x":259,"y":86,"width":155,"height":220},"region_attributes":{"track":322}}],"file_attributes":{"shot":124}},"./images/00011625.jpg60147":{"filename":"./images/00011625.jpg","size":"60147","regions":[{"shape_attributes":{"name":"rect","x":263,"y":103,"width":149,"height":194},"region_attributes":{"track":322}}],"file_attributes":{"shot":124}},"./images/00011626.jpg61104":{"filename":"./images/00011626.jpg","size":"61104","regions":[{"shape_attributes":{"name":"rect","x":263,"y":75,"width":146,"height":216},"region_attributes":{"track":322}}],"file_attributes":{"shot":124}},"./images/00011627.jpg59620":{"filename":"./images/00011627.jpg","size":"59620","regions":[{"shape_attributes":{"name":"rect","x":253,"y":95,"width":146,"height":189},"region_attributes":{"track":322}}],"file_attributes":{"shot":124}},"./images/00011628.jpg59100":{"filename":"./images/00011628.jpg","size":"59100","regions":[{"shape_attributes":{"name":"rect","x":252,"y":95,"width":141,"height":182},"region_attributes":{"track":322}}],"file_attributes":{"shot":124}},"./images/00011629.jpg59267":{"filename":"./images/00011629.jpg","size":"59267","regions":[{"shape_attributes":{"name":"rect","x":248,"y":94,"width":144,"height":177},"region_attributes":{"track":322}}],"file_attributes":{"shot":124}},"./images/00011630.jpg56647":{"filename":"./images/00011630.jpg","size":"56647","regions":[{"shape_attributes":{"name":"rect","x":261,"y":72,"width":147,"height":195},"region_attributes":{"track":322}}],"file_attributes":{"shot":124}},"./images/00011631.jpg57431":{"filename":"./images/00011631.jpg","size":"57431","regions":[{"shape_attributes":{"name":"rect","x":254,"y":90,"width":140,"height":182},"region_attributes":{"track":322}}],"file_attributes":{"shot":124}},"./images/00011632.jpg57626":{"filename":"./images/00011632.jpg","size":"57626","regions":[{"shape_attributes":{"name":"rect","x":252,"y":87,"width":142,"height":185},"region_attributes":{"track":322}}],"file_attributes":{"shot":124}},"./images/00011633.jpg59328":{"filename":"./images/00011633.jpg","size":"59328","regions":[{"shape_attributes":{"name":"rect","x":251,"y":88,"width":141,"height":181},"region_attributes":{"track":322}}],"file_attributes":{"shot":124}},"./images/00011634.jpg59155":{"filename":"./images/00011634.jpg","size":"59155","regions":[{"shape_attributes":{"name":"rect","x":253,"y":83,"width":137,"height":184},"region_attributes":{"track":322}}],"file_attributes":{"shot":124}},"./images/00011635.jpg59248":{"filename":"./images/00011635.jpg","size":"59248","regions":[{"shape_attributes":{"name":"rect","x":246,"y":70,"width":154,"height":200},"region_attributes":{"track":322}}],"file_attributes":{"shot":124}},"./images/00011636.jpg60784":{"filename":"./images/00011636.jpg","size":"60784","regions":[{"shape_attributes":{"name":"rect","x":252,"y":77,"width":139,"height":188},"region_attributes":{"track":322}}],"file_attributes":{"shot":124}},"./images/00011637.jpg60421":{"filename":"./images/00011637.jpg","size":"60421","regions":[{"shape_attributes":{"name":"rect","x":237,"y":71,"width":158,"height":196},"region_attributes":{"track":322}}],"file_attributes":{"shot":124}},"./images/00011638.jpg60527":{"filename":"./images/00011638.jpg","size":"60527","regions":[{"shape_attributes":{"name":"rect","x":252,"y":78,"width":139,"height":190},"region_attributes":{"track":322}}],"file_attributes":{"shot":124}},"./images/00011639.jpg60688":{"filename":"./images/00011639.jpg","size":"60688","regions":[{"shape_attributes":{"name":"rect","x":252,"y":80,"width":139,"height":190},"region_attributes":{"track":322}}],"file_attributes":{"shot":124}},"./images/00011640.jpg62201":{"filename":"./images/00011640.jpg","size":"62201","regions":[{"shape_attributes":{"name":"rect","x":247,"y":68,"width":147,"height":199},"region_attributes":{"track":322}}],"file_attributes":{"shot":124}},"./images/00011641.jpg60548":{"filename":"./images/00011641.jpg","size":"60548","regions":[{"shape_attributes":{"name":"rect","x":250,"y":82,"width":139,"height":190},"region_attributes":{"track":322}}],"file_attributes":{"shot":124}},"./images/00011642.jpg60665":{"filename":"./images/00011642.jpg","size":"60665","regions":[{"shape_attributes":{"name":"rect","x":244,"y":72,"width":155,"height":199},"region_attributes":{"track":322}}],"file_attributes":{"shot":124}},"./images/00011643.jpg60709":{"filename":"./images/00011643.jpg","size":"60709","regions":[{"shape_attributes":{"name":"rect","x":244,"y":73,"width":153,"height":197},"region_attributes":{"track":322}}],"file_attributes":{"shot":124}},"./images/00011644.jpg61404":{"filename":"./images/00011644.jpg","size":"61404","regions":[{"shape_attributes":{"name":"rect","x":243,"y":68,"width":145,"height":195},"region_attributes":{"track":322}}],"file_attributes":{"shot":124}},"./images/00011645.jpg59743":{"filename":"./images/00011645.jpg","size":"59743","regions":[{"shape_attributes":{"name":"rect","x":242,"y":76,"width":165,"height":186},"region_attributes":{"track":322}}],"file_attributes":{"shot":124}},"./images/00011646.jpg60679":{"filename":"./images/00011646.jpg","size":"60679","regions":[{"shape_attributes":{"name":"rect","x":241,"y":75,"width":154,"height":200},"region_attributes":{"track":322}}],"file_attributes":{"shot":124}},"./images/00011647.jpg59950":{"filename":"./images/00011647.jpg","size":"59950","regions":[{"shape_attributes":{"name":"rect","x":239,"y":75,"width":152,"height":199},"region_attributes":{"track":322}}],"file_attributes":{"shot":124}},"./images/00011648.jpg60576":{"filename":"./images/00011648.jpg","size":"60576","regions":[{"shape_attributes":{"name":"rect","x":242,"y":73,"width":151,"height":200},"region_attributes":{"track":322}}],"file_attributes":{"shot":124}},"./images/00011649.jpg60219":{"filename":"./images/00011649.jpg","size":"60219","regions":[{"shape_attributes":{"name":"rect","x":239,"y":76,"width":154,"height":199},"region_attributes":{"track":322}}],"file_attributes":{"shot":124}}}';
